
#include <iostream>
#include <cmath>

class gradient_method {
    protected:
        int n;
        double * x;
        double (*f)(double);
        double (*df)(double);
        double omega;
        double b;
    public:
        gradient_method(){
            n=0;
            x=nullptr;
            f=nullptr;
            df=nullptr;
            b=0;
            omega=0;
        }
        gradient_method(int m,double (*g)(double),double (*dg)(double)){
            f=g;
            df=dg;
            n=m;
            b=0;
            omega=0;
            x = new double[n];
        }
        void compute_gradient(double grad_w, double grad_b);
};


class simple_gradient: public gradient_method {
    protected:
        double eta;
    public:
        simple_gradient(): gradient_method(){
            eta=0.0;
        }
       simple_gradient(int m,double (*g)(double),double (*dg)(double), double eta): gradient_method(m,g,dg){
            eta=eta;
        }
        void solve_gradient(int nb_iter);
};

class momentum: public gradient_method {
    protected:
        double eta;
        double alpha;
    public:
        momentum(): gradient_method(){
            eta=0.0;
            alpha=0.0;
        }
       momentum(int m,double (*g)(double),double (*dg)(double), double eta, double alpha): gradient_method(m,g,dg){
            eta=eta;
            alpha=alpha;
        }
        void solve_gradient(int nb_iter);
};

class adagrad: public gradient_method {
    protected:
        double eta;
        double eps;
    public:
        adagrad(): gradient_method(){
            eta=0.0;
            eps=0.0;
        }
       adagrad(int m,double (*g)(double),double (*dg)(double), double eta, double eps): gradient_method(m,g,dg){
            eta=eta;
            eps=eps;
        }
        void solve_gradient(int nb_iter);
};
